function [J grad] = costFunkce(nn_params, ...
                                   input_layer_size, ...
                                   hidden_layer_size, ...
                                   num_labels, ...
                                   X, y, lambda)

% rozbaleni theta promennych pro 3 vsrstvou sit
Theta1 = reshape(nn_params(1:hidden_layer_size * (input_layer_size + 1)), ...
                 hidden_layer_size, (input_layer_size + 1));

Theta2 = reshape(nn_params((1 + (hidden_layer_size * (input_layer_size + 1))):end), ...
                 num_labels, (hidden_layer_size + 1));

% Setup some useful variables
m = size(X, 1);
         
% inicializace promennych ktere vratime
J = 0;
Theta1_grad = zeros(size(Theta1));
Theta2_grad = zeros(size(Theta2));

%vectorizing result
result=zeros(num_labels,m);
for i=1:num_labels
	result(i,:) = y==i;
end		

%prvni pruchod a vypocet aktivacnich funci, pridani bias neuronu
a1 = [ones(m,1),X];
XTemp = a1;
a2=sigmoidFunkce(XTemp*Theta1');

XTemp = a2;
XTemp = [ones(m,1),XTemp]; 
a3=sigmoidFunkce(XTemp*Theta2');
%a3 == metrice(5000*10)

z2=a1*Theta1';
a2=sigmoidFunkce(z2);

a2= [ones(m,1),a2]; 
z3=a2*Theta2';
a3=sigmoidFunkce(z3);

%regularizace
Regular = sum(sum(Theta1(:,2:end).^2))+sum(sum(Theta2(:,2:end).^2));

%vypocet cost funkce s regularizaci
J=(1/m)*sum(sum((-result'.*log(a3)-(1-result').*log(1-a3))))+(lambda/(2*m))*Regular;

%inicializace chyb
delta3 = zeros(num_labels,1);
delta2 = zeros(hidden_layer_size,1);

%vypocet chyby na vystupni vrstve
delta3 = a3'-result;

%pryc s biasem a vypocet chyby na skryte vrstve
delta2 =Theta2(:,2:end)'*delta3.*sigmoidFunkceDerivace(z2)';

%vypocet theta gradientu
Theta1_grad =delta2*a1./m + (lambda/m) * [zeros(size(Theta1, 1), 1) Theta1(:,2:end)];
Theta2_grad = delta3*a2./m + (lambda/m) * [zeros(size(Theta2, 1), 1) Theta2(:,2:end)];


% zabaleni theta gradientu
grad = [Theta1_grad(:) ; Theta2_grad(:)];


end
