
%% load dat
fprintf('Nacteni a vizualizace dat...\n')

load('data.mat');
m = size(X, 1);

% Nahodny vyber 100 obrazku
sel = randperm(size(X, 1));
sel = sel(1:100);

zobrazeniDat(X(sel, :));

fprintf('Ukazka dat...\n')
fprintf('Program je stopnut. Pro pokracovani stikni enter');

%% Trenovani site
%nahodna inicializace vah v neuronove siti
input_layer_size  = 400;  % 20x20 vstupnich pixelu obrazku
hidden_layer_size = 25;   % 25 neuronu na skryte vrstve
num_labels = 10;          % 10 moznosti vystupu (10 cisel)

initial_Theta1 = inicializaceVah(input_layer_size, hidden_layer_size);
initial_Theta2 = inicializaceVah(hidden_layer_size, num_labels);

% zabaleni vah
initial_nn_params = [initial_Theta1(:) ; initial_Theta2(:)];


%trenovani neuronove site
%gradientDescent napsana funkce ktera iteruje a kazdou iteraci se snizuje J
%fmincg je externi knihovna pro to same
fprintf('\nTrenovani site... \n')

%nastaveni pro fmincf knihovnu
options = optimset('MaxIter', 50);

%inicializace lambdy
lambda = 1;


%gradient descent
[nn_params, cost] = fmincg(@(p)costFunkce(p,input_layer_size, hidden_layer_size,num_labels, X, y, lambda),initial_nn_params, options);

%porovnani vysledku bou postupu tak ze secteme jejich rozdil
fprintf('Program je stopnut. Pro pokracovani stikni enter');

% rozbaleni vracenych vah
% Theta 1 a 2 z externi knihovny
% Theta 12 a 22 z gradientDescent algoritmu
Theta1 = reshape(nn_params(1:hidden_layer_size * (input_layer_size + 1)),hidden_layer_size,(input_layer_size + 1));

Theta2 = reshape(nn_params((1 + (hidden_layer_size * (input_layer_size + 1))):end),num_labels, (hidden_layer_size + 1));


%zobrazeni skryte vrstvy (neuronove site)

fprintf('\nVizualizace site\n')

zobrazeniDat(Theta1(:, 2:end));

fprintf('Program je stopnut. Pro pokracovani stikni enter');

%% testovani site
rp = randperm(m);
%testovani dat
for i = 1:100
    %% Rozpoznani dat
    % Display 
    fprintf('\nDisplaying Example Image\n');
    zobrazeniDat(X(rp(i), :));

    pred = hadani(Theta1, Theta2, X(rp(i),:));
    fprintf('\nPredikce neuronove site: %d (digit %d)\n', pred, mod(pred, 10));
    
    % Pause
    pause
    fprintf('Program je stopnut. Pro pokracovani stikni enter.\n');
end
