
%% load dat
fprintf('Nacteni a vizualizace dat...\n')

load('data.mat');
m = size(X, 1);

% Nahodny vyber 100 obrazku
sel = randperm(size(X, 1));
sel = sel(1:100);

zobrazeniDat(X(sel, :));

fprintf('Ukazka dat...\n')
fprintf('Program je stopnut. Pro pokracovani stikni enter');
pause;

%% Trenovani site
%nahodna inicializace vah v neuronove siti
input_layer_size  = 400;  % 20x20 vstupnich pixelu obrazku
hidden_layer_size = 25;   % 25 neuronu na skryte vrstve
num_labels = 10;          % 10 moznosti vystupu (10 cisel)

initial_Theta1 = inicializaceVah(input_layer_size, hidden_layer_size);
initial_Theta2 = inicializaceVah(hidden_layer_size, num_labels);

% zabaleni vah
initial_nn_params = [initial_Theta1(:) ; initial_Theta2(:)];


%trenovani neuronove site
%gradientDescent napsana funkce ktera iteruje a kazdou iteraci se snizuje J
%fmincg je externi knihovna pro to same
fprintf('\nTrenovani site... \n')

%nastaveni pro fmincf knihovnu
options = optimset('MaxIter', 125);

%inicializace lambdy
lambda = 1;


%gradient descent
[nn_params, cost] = fmincg(@(p)costFunkce(p,input_layer_size, hidden_layer_size,num_labels, X, y, lambda),initial_nn_params, options);

%porovnani vysledku bou postupu tak ze secteme jejich rozdil
fprintf('Program je stopnut. Pro pokracovani stikni enter');
pause;

% rozbaleni vracenych vah
% Theta 1 a 2 z externi knihovny
% Theta 12 a 22 z gradientDescent algoritmu
Theta1 = reshape(nn_params(1:hidden_layer_size * (input_layer_size + 1)),hidden_layer_size,(input_layer_size + 1));

Theta2 = reshape(nn_params((1 + (hidden_layer_size * (input_layer_size + 1))):end),num_labels, (hidden_layer_size + 1));


%zobrazeni skryte vrstvy (neuronove site)

fprintf('\nVizualizace site\n')

zobrazeniDat(Theta1(:, 2:end));

fprintf('Program je stopnut. Pro pokracovani stikni enter');
pause;

%% testovani site
rp = randperm(m);
%testovani dat
for i = 1:40
    % Display 
    fprintf('\nDisplaying Example Image\n');
    zobrazeniDat(X(rp(i), :));

    pred = hadani(Theta1, Theta2, X(rp(i),:));
    fprintf('\nPredikce neuronove site: %d (digit %d)\n', pred, mod(pred, 10));
    
    % Pause
    fprintf('Program je stopnut. Pro pokracovani stikni enter.\n');
pause;
end

%% pokus o detekci z naskenovanych obrazu - segmentace
 I = imread('cisla.png');
imshow(I);
disp('Originalni obraz');
pause;
disp('Program je stopnut. Pro pokracovani stikni enter');

G = grayscale(I);
imshow(G);
disp('Sedoton');
pause;
disp('Program je stopnut. Pro pokracovani stikni enter');


G = medfilt2(G);
imshow(G);
disp('Program je stopnut. Pro pokracovani stikni enter');
pause;

T = otsu(G);


G = hranice(G);
imshow(G);
disp('Hranova detekce');

G= prahovani(G,T);
imshow(G);
disp('Prahovani');
disp('Program je stopnut. Pro pokracovani stikni enter');
pause;

G=imfill(G, 'holes');

strel=[1,1,1,1,1;1,1,1,1,1;1,1,1,1,1;1,1,1,1,1;1,1,1,1,1];
G= pridani(G,strel);
imshow(G);
disp('zvyrazneni');
disp('Program je stopnut. Pro pokracovani stikni enter');
pause;

[G sum] = spojovani(G,[1,1,1;1,1,1;1,1,1]);

stats = regionprops(G,'BoundingBox');

 rectangles = zeros(10,4);
for i=1:size(stats,1)
rectangles(i,:) = stats(i).BoundingBox;
end

rectangles = rectangles + repmat([-4 -4 8 8]', 1, length(rectangles))';
cropImages = zeros(length(rectangles),400);

disp('Rectangles');
disp('Program je stopnut. Pro pokracovani stikni enter');
pause;

another = zeros(20,20,3);
wider = 14;
color = 200;

%% hadani rozsegmentovanych cislic

for i=1:length(rectangles)
    if rectangles(i,3)>50
image=imcrop(I, rectangles(i, :));
tmp = size(image);
another = zeros(tmp(1) + 2*wider, tmp(2) + 2*wider, 3);
temp = [repmat(image(:,1,2), 1, wider) image(:,:,1) repmat(image(:,length(rectangles(1,:)),2),1,wider)];
temp = [repmat(temp(1,:),wider, 1); temp; repmat(temp(length(rectangles(1,:)),:),wider,1)];
another(:,:,1) = temp;
temp = [repmat(image(:,1,2), 1, wider) image(:,:,2) repmat(image(:,length(rectangles(1,:)),2),1,wider)];
temp = [repmat(temp(1,:),wider, 1); temp; repmat(temp(length(rectangles(1,:)),:),wider,1)];
another(:,:,2) = temp;
temp = [repmat(image(:,1,3), 1, wider) image(:,:,3) repmat(image(:,length(rectangles(1,:)),3),1,wider)];
temp = [repmat(temp(1,:),wider, 1); temp; repmat(temp(length(rectangles(1,:)),:),wider,1)];
another(:,:,3) = temp;
another = imresize(another, [200 200]);
%% jednolive cislice
image = toGray(another);
zobrazeniDat(image);
pred = hadani(Theta1, Theta2, image);
fprintf('\nPredikce neuronove site: %d (digit %d)\n', pred, mod(pred, 10));
pause;
    end
end;


%% naskenovane fotky cislic
image = toGrayOriginal('6.JPG', 0 , 0, 50);
zobrazeniDat(image);
pred = hadani(Theta1, Theta2, image);
fprintf('\nPredikce neuronove site: %d (digit %d)\n', pred, mod(pred, 10));
    fprintf('Program je stopnut. Pro pokracovani stikni enter.\n');
pause;
    
    %% naskenovane fotky cislic
    
    image = toGrayOriginal('4.JPG', 0 , 0, 50);
zobrazeniDat(image);
pred = hadani(Theta1, Theta2, image);
fprintf('\nPredikce neuronove site: %d (digit %d)\n', pred, mod(pred, 10));
   
    fprintf('Program je stopnut. Pro pokracovani stikni enter.\n');
pause;
    
    %% naskenovane fotky cislic
    
    image = toGrayOriginal('8.jpg', 0 , 0, 25);
zobrazeniDat(image);
pred = hadani(Theta1, Theta2, image);
fprintf('\nPredikce neuronove site: %d (digit %d)\n', pred, mod(pred, 10));
    
pause;
    fprintf('Program je stopnut. Pro pokracovani stikni enter.\n');